
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Answer_choicesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const answer_choices = await db.answer_choices.create(
            {
                id: data.id || undefined,
        
        content: data.content
        ||
        null
            ,
            
        is_correct: data.is_correct
        ||
        false
        
            ,
            
        sort_order: data.sort_order
        ||
        null
            ,
            
        feedback: data.feedback
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await answer_choices.setQuestion( data.question || null, {
            transaction,
        });
        

        

        

        return answer_choices;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const answer_choicesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                content: item.content
            ||
            null
            ,
            
                is_correct: item.is_correct
            ||
            false
        
            ,
            
                sort_order: item.sort_order
            ||
            null
            ,
            
                feedback: item.feedback
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const answer_choices = await db.answer_choices.bulkCreate(answer_choicesData, { transaction });

        // For each item created, replace relation files
        

        return answer_choices;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const answer_choices = await db.answer_choices.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.content !== undefined) updatePayload.content = data.content;
        
        
        if (data.is_correct !== undefined) updatePayload.is_correct = data.is_correct;
        
        
        if (data.sort_order !== undefined) updatePayload.sort_order = data.sort_order;
        
        
        if (data.feedback !== undefined) updatePayload.feedback = data.feedback;
        
        
        updatePayload.updatedById = currentUser.id;

        await answer_choices.update(updatePayload, {transaction});

        
        
        if (data.question !== undefined) {
            await answer_choices.setQuestion(
              
              data.question,
              
              { transaction }
            );
        }
        

        
        

        

        return answer_choices;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const answer_choices = await db.answer_choices.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of answer_choices) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of answer_choices) {
                await record.destroy({transaction});
            }
        });


        return answer_choices;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const answer_choices = await db.answer_choices.findByPk(id, options);

        await answer_choices.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await answer_choices.destroy({
            transaction
        });

        return answer_choices;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const answer_choices = await db.answer_choices.findOne(
            { where },
            { transaction },
        );

        if (!answer_choices) {
            return answer_choices;
        }

        const output = answer_choices.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.question = await answer_choices.getQuestion({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.questions,
        as: 'question',
        
        where: filter.question ? {
          [Op.or]: [
            { id: { [Op.in]: filter.question.split('|').map(term => Utils.uuid(term)) } },
            {
              content: {
                [Op.or]: filter.question.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.content) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'answer_choices',
                        'content',
                        filter.content,
                    ),
                };
            }
            
            if (filter.feedback) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'answer_choices',
                        'feedback',
                        filter.feedback,
                    ),
                };
            }
            

            
            

            
            if (filter.sort_orderRange) {
                const [start, end] = filter.sort_orderRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_correct) {
                where = {
                    ...where,
                is_correct: filter.is_correct,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.answer_choices.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'answer_choices',
                        'content',
                        query,
                    ),
                ],
            };
        }

        const records = await db.answer_choices.findAll({
            attributes: [ 'id', 'content' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['content', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.content,
        }));
    }

    
};

